import os.path, time
from ctypes import *

kernel32 = windll.kernel32

winpath = os.environ['WINDIR']
print 'WINDIR: %s'%winpath

class FILETIME(Structure):
  _fields_ = [("dwLowDateTime", c_int),
             ("dwHighDateTime", c_int)]

kernel32.GetFileTime.argtypes = [c_int, c_void_p, c_void_p, c_void_p]
CreationTime = FILETIME(0,0)
LastAccessTime = FILETIME(0,0)
LastWriteTime = FILETIME(0,0)

fh = kernel32.CreateFileA(winpath, 0x80000000, 3, 0, 3, 0x2000000, 0)
kernel32.GetFileTime(fh, byref(CreationTime), byref(LastAccessTime), byref(LastWriteTime))
kernel32.CloseHandle(fh)

ZZ1 = CreationTime.dwLowDateTime         # 0x005F80E0
ZZ2 = CreationTime.dwHighDateTime        # 0x005F80E4

#print '0x%X--0x%X'%(ZZ1,ZZ2)

name = os.environ['COMPUTERNAME']
print 'COMPUTERNAME: %s'%name

tbl = ['3','1','8','5','4','7','0','2','9','6']

xx_val2 = 2                                         # 0x005F80CC
yy_val2 = 5                                         # 0x005F80D0
val2 = xx_val2*yy_val2                              # 0x005F80C8
ZZ = 1                                              # 0x005F80D4
for i in xrange(6):
   ZZ *= val2
val1 = (((ZZ2^ZZ1)*ZZ1)&0xFFFFFFFF)%ZZ              # 0x005F80C4

K = 0x1A                                            # register
for i in xrange(len(name)):
    K ^= ord(name[i])

hwid = ''
out = ''
for i in xrange(6):
   a = val1 % val2                                  # a[6] -> 0x005F80D8
   val1 = val1 // val2
   if i == 1:
      a = K % val2
   if i == 5:
      a = (K // val2) % val2
   hwid += chr(0x30+a)
   out += tbl[a]
   if i == 2:
      out += ' '

print 'HardwareID: '+hwid
print 'License number: '+out

